sketch.default2d();

inlets=1;
outlets=2;

var vertices = [-1, 1, 1, 1, 1, -1, -1, -1];
var vertex = -1;
var lastMousPos = [0, 0];
var posxy = [0, 0];
var vpos = 0;
var glzoom = 1;
var circ = 0.06;

draw();
initialze();

function initialze(){
	sketch.glscale(0.8, 0.8, 1.);
	draw();
}

function zoom(val){
	glzoom = val
	sketch.glscale(glzoom, glzoom, 1.);
	circ = circ / glzoom;
	bang();
}

function corners(){
	vertices = arrayfromargs(arguments);
	bang();
}

function setcorners(){
	vertices = arrayfromargs(arguments);
	draw();
	refresh();
}

function pos(){
	var XY = arrayfromargs(arguments);
	posxy [0] = (XY[0]);
	posxy [1] = (XY[1] * -1);
	bang();
}

function setpos(){
	var XY = arrayfromargs(arguments);
	posxy [0] = (XY[0]);
	posxy [1] = (XY[1] * -1);
	draw();
	refresh();
}

function draw(){		
	with (sketch) {
		glclearcolor(0.6, 0.6, 0.7, 1);
		glclear();

		glcolor(0.5, 0.5, 0.6, 1);
		linesegment(0, 500, 0, 0, -500, 0);
		linesegment(500, 0, 0, -500, 0, 0);
		framequad( -1, 1, 0, 1, 1, 0, 1, -1, 0, -1, -1, 0);
		
		glcolor(0.3, 0.3, 1, 1);
		moveto(posxy);
		circle(circ);
		
		glcolor(1, 1 ,0.5, 1);
		for(var index = 0; index < 7; index += 2){
			moveto(vertices[index], vertices[index + 1]);
			circle(circ);
			if(index + 3 < 8) lineto(vertices[index + 2], vertices[index + 3]);
			else lineto(vertices[0], vertices[1]);
		}
	}
}
draw.local = 1;

function bang(){
	draw();
	output();
	refresh();
}

function onclick(x,y, but){
		var point = sketch.screentoworld(x,y);
		vertex = -1;
		vpos = 0;
		
		if (point[0] < posxy[0] + circ && point[0] > posxy[0] - circ 
			&& point[1] < posxy[1] + circ && point[1] > posxy[1] - circ){
		vpos = 1;
		}
		
		else {
		vpos = 0;
		}
	
		for( var i = 0; i < vertices.length - 1; i += 2){
			if(point[0] < vertices[i] + circ && point[0] > vertices[i] - circ 
				&& point[1] < vertices[i + 1] + circ && point[1] > vertices[i + 1] - circ){
					vertex = i;
					break;
			}
		}
	lastMousePos = point;	
}
onclick.local = 1;

function ondrag(x,y,but,cmd,shift,capslock,option,ctrl){
	if(but == 1){
		var pos = sketch.screentoworld(x,y);
	
		if (shift) { 
			if(vertex >= 0){
				var xMove = lastMousePos[0] - pos [0];
				var yMove = lastMousePos[1] - pos[1];
				var xVal = 	vertices[vertex] - xMove * 0.02;
				var yVal = vertices[vertex + 1] - yMove * 0.02;
 				vertices[vertex] = xVal;
				vertices[vertex + 1] = yVal;
				bang();
			}
			else if(vpos >= 1){
				var xMove = lastMousePos[0] - pos [0];
				var yMove = lastMousePos[1] - pos[1];
				var xVal = 	posxy[0] - xMove * 0.02;
				var yVal = posxy[1] - yMove * 0.02;
				posxy[0] = xVal;
				posxy[1] = yVal;
				bang();
			}	
				
		} else {
			if(vertex >= 0){
 				vertices[vertex] = pos[0];
				vertices[vertex + 1] = pos[1];
				bang();
			}
			else if(vpos >= 1){
				posxy = pos;
				bang();
			}
		}
		lastMousePos = pos; 
	}
		notifyclients();
}

ondrag.local = 1;

function output(){
	var out1 = [1, -1, 1];
	var out2 = [0, 0];
		
	for( var i = 0; i < 7; i += 2){
			if(i == 0) out1[0] = 1;
			else if(i == 2) out1[0] = 2;
			else if(i == 4) out1[0] = 4;
			else out1[0] = 3;
			
			out1[1] = (vertices[i]);
			out1[2] = (vertices[i + 1] * -1);
			
			outlet(0, out1);
		}
	if(vpos = 1){	
		out2 [0] = (posxy[0]);	
		out2 [1] = (posxy[1] * -1);
	
		outlet(1, out2);
		}
	}

output.local = 1;




